Name:           AutoScan_Daemon 
Summary:        Utility for network exploration (Samba,Nessus client).
Version:        1.02 
Release:        0
Source0:        %{name}.%{version}.tar.gz
URL:            http://autoscan.free.fr
Group:		Networking/Other
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot 
License:        GNU General Public License (GPL)
BuildRequires:  libopenssl0.9.7-devel
BuildRequires:  libnet-snmp5-devel
BuildRequires:  libelfutils1-devel


%description
AutoScan is an application designed to explore and to manage your network. Entire subnets can be scanned simultaneously without human intervention. It features OS detection, automatic network discovery, a port scanner, a Samba share browser, and the ability to save the network state.

%prep  
%setup -q -a 0

%build
./configure mandriva
make AutoScan_Agent

%install
rm -rf %{buildroot}
install -d %{buildroot}/usr/sbin/
install -d %{buildroot}/etc/rc.d/init.d/
install -m755 src/AutoScan_Agent/AutoScan_Agent %{buildroot}/usr/sbin/
install -m755 init.d/autoscan_mandriva %{buildroot}/etc/rc.d/init.d/autoscan


%clean
rm -rf $RPM_BUILD_ROOT/


%post
chkconfig --add autoscan


%postun
/etc/rc.d/init.d/autoscan stop
chkconfig --del autoscan


%files
%defattr(755,root,root)
   /usr/sbin/*
   /etc/rc.d/init.d/*

%changelog
* Sat Dec 16 2006 Thierry Lagarde<tlagarde@users.sourceforge.net>
 - initial build 


